javax.faces.validator

## Class BeanValidator

- java.lang.Object
- - javax.faces.validator.BeanValidator

- All Implemented Interfaces:
    EventListener, PartialStateHolder, StateHolder, Validator

      public class BeanValidator
      extends Object
      implements Validator, PartialStateHolder

  A Validator that delegates validation of the bean property to the Bean Validation API.

  Since:
    2.0

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `DISABLE_DEFAULT_BEAN_VALIDATOR_PARAM_NAME` If this param is defined, and calling `toLowerCase().equals(“true”)` on a `String` representation of its value returns `true`, the runtime must not automatically add the validator with validator-id equal to the value of the symbolic constant `VALIDATOR_ID` to the list of default validators.
    `static String` | `EMPTY_VALIDATION_GROUPS_PATTERN` The regular expression pattern that identifies an empty list of validation groups.
    `static String` | `MESSAGE_ID` The message identifier of the `FacesMessage` to be created if a constraint failure is found.
    `static String` | `VALIDATION_GROUPS_DELIMITER` The delimiter that is used to separate the list of fully-qualified group names as strings.
    `static String` | `VALIDATOR_FACTORY_KEY` The name of the servlet context attribute which holds the object used by JSF to obtain Validator instances.
    `static String` | `VALIDATOR_ID` The standard validator id for this validator, as defined by the JSF specification.

    - ### Fields inherited from interface javax.faces.validator.Validator

      `NOT_IN_RANGE_MESSAGE_ID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BeanValidator()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clearInitialState()` Reset the PartialStateHolder to a non-delta tracking state.
    `String` | `getValidationGroups()` Return the validation groups passed to the Validation API when checking constraints.
    `boolean` | `initialStateMarked()` Return `true` if delta state changes are being tracked, otherwise `false`
    `boolean` | `isTransient()` If true, the Object implementing this interface must not participate in state saving or restoring.
    `void` | `markInitialState()` The runtime must ensure that the `PartialStateHolder.markInitialState()` method is called on each instance of this interface in the view at the appropriate time to indicate the component is in its initial state.
    `void` | `restoreState(FacesContext context, Object state)` Perform any processing required to restore the state from the entries in the state Object.
    `Object` | `saveState(FacesContext context)` Gets the state of the instance as a `Serializable` Object.
    `void` | `setTransient(boolean transientValue)` Denotes whether or not the Object implementing this interface must or must not participate in state saving or restoring.
    `void` | `setValidationGroups(String validationGroups)` A comma-separated list of validation groups which are used to filter which validations get checked by this validator.
    `void` | `validate(FacesContext context, UIComponent component, Object value)` Verify that the value is valid according to the Bean Validation constraints.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### VALIDATOR_ID

          public static final String VALIDATOR_ID

      The standard validator id for this validator, as defined by the JSF specification.

      See Also:
        Constant Field Values

    - #### MESSAGE_ID

          public static final String MESSAGE_ID

      The message identifier of the `FacesMessage` to be created if a constraint failure is found. The message format string for this message may optionally include the following placeholders:

      - `{0}` replaced by the interpolated message from Bean Validation.
      - `{1}` replaced by a `String` whose value is the label of the input component that produced this message.

      The message format string provided by the default implementation should be a the placeholder {0}, thus fully delegating the message handling to Bean Validation. A developer can override this message format string to make it conform to other JSF validator messages (i.e., by including the component label)

      See Also:
        Constant Field Values

    - #### VALIDATOR_FACTORY_KEY

          public static final String VALIDATOR_FACTORY_KEY

      The name of the servlet context attribute which holds the object used by JSF to obtain Validator instances. If the servlet context attribute is missing or contains a null value, JSF is free to use this servlet context attribute to store the ValidatorFactory bootstrapped by this validator.

      See Also:
        Constant Field Values

    - #### VALIDATION_GROUPS_DELIMITER

          public static final String VALIDATION_GROUPS_DELIMITER

      The delimiter that is used to separate the list of fully-qualified group names as strings.

      See Also:
        Constant Field Values

    - #### EMPTY_VALIDATION_GROUPS_PATTERN

          public static final String EMPTY_VALIDATION_GROUPS_PATTERN

      The regular expression pattern that identifies an empty list of validation groups.

      See Also:
        Constant Field Values

    - #### DISABLE_DEFAULT_BEAN_VALIDATOR_PARAM_NAME

          public static final String DISABLE_DEFAULT_BEAN_VALIDATOR_PARAM_NAME

      If this param is defined, and calling `toLowerCase().equals(“true”)` on a `String` representation of its value returns `true`, the runtime must not automatically add the validator with validator-id equal to the value of the symbolic constant `VALIDATOR_ID` to the list of default validators. Setting this parameter to `true` will have the effect of disabling the automatic installation of Bean Validation to every input component in every view in the application, though manual installation is still possible.

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### BeanValidator

          public BeanValidator()

  - ### Method Detail

    - #### setValidationGroups

          public void setValidationGroups(String validationGroups)

      A comma-separated list of validation groups which are used to filter which validations get checked by this validator. If the validationGroupsArray attribute is omitted or is empty, the validation groups will be inherited from the branch defaults or, if there are no branch defaults, the `Default` group will be used.

      Parameters:
        `validationGroups` - comma-separated list of validation groups (string with only spaces and commas treated as null)

    - #### getValidationGroups

          public String getValidationGroups()

      Return the validation groups passed to the Validation API when checking constraints. If the validationGroupsArray attribute is omitted or empty, the validation groups will be inherited from the branch defaults, or if there are no branch defaults, the `Default` group will be used.

    - #### validate

          public void validate(FacesContext context,
                      UIComponent component,
                      Object value)

      Verify that the value is valid according to the Bean Validation constraints.

      Obtain a `ValidatorFactory` instance by calling `Validation.buildDefaultValidatorFactory()`.

      Let validationGroupsArray be a `Class []` representing validator groups set on the component by the tag handler for this validator. The first search component terminates the search for the validation groups value. If no such value is found use the class name of `Default` as the value of the validation groups.

      Let valueExpression be the return from calling `UIComponent.getValueExpression(java.lang.String)` on the argument component, passing the literal string “value” (without the quotes) as an argument. If this application is running in an environment with a Unified EL Implementation for Java EE6 or later, obtain the `ValueReference` from valueExpression and let valueBaseClase be the return from calling `ValueReference.getBase()` and valueProperty be the return from calling `ValueReference.getProperty()`. If an earlier version of the Unified EL is present, use the appropriate methods to inspect valueExpression and derive values for valueBaseClass and valueProperty.

      If no `ValueReference` can be obtained, take no action and return.

      If `ValueReference.getBase()` return `null`, take no action and return.

      Obtain the `ValidatorContext` from the `ValidatorFactory`.

      Decorate the `MessageInterpolator` returned from `ValidatorFactory.getMessageInterpolator()` with one that leverages the `Locale` returned from `UIViewRoot.getLocale()`, and store it in the `ValidatorContext` using `ValidatorContext.messageInterpolator(javax.validation.MessageInterpolator)`.

      Obtain the `Validator` instance from the `validatorContext`.

      Obtain a `javax.validation.BeanDescriptor` from the `javax.validation.Validator`. If `hasConstraints()` on the `BeanDescriptor` returns false, take no action and return. Otherwise proceed.

      Call `Validator.validateValue(java.lang.Class<T>, java.lang.String, java.lang.Object, java.lang.Class<?>...)`, passing valueBaseClass, valueProperty, the value argument, and validatorGroupsArray as arguments.

      If the returned `Set<`ConstraintViolation`>` is non-empty, for each element in the `Set`, create a `FacesMessage` where the summary and detail are the return from calling `ConstraintViolation.getMessage()`. Capture all such `FacesMessage` instances into a `Collection` and pass them to `ValidatorException.ValidatorException(java.util.Collection)`, throwing the new exception.

      Specified by:
        `validate` in interface `Validator`
      Parameters:
        `context` - FacesContext for the request we are processing
        `component` - UIComponent we are checking for correctness
        `value` - the value to validate
      Throws:
        `ValidatorException` - if validation fails

    - #### saveState

          public Object saveState(FacesContext context)

      Description copied from interface: `StateHolder`

      Gets the state of the instance as a `Serializable` Object.

      If the class that implements this interface has references to instances that implement StateHolder (such as a `UIComponent` with event handlers, validators, etc.) this method must call the `StateHolder.saveState(javax.faces.context.FacesContext)` method on all those instances as well. This method must not save the state of children and facets. That is done via the `StateManager`

      This method must not alter the state of the implementing object. In other words, after executing this code:

      `

           Object state = component.saveState(facesContext);

      `

      `component` should be the same as before executing it.

      The return from this method must be `Serializable`

      Specified by:
        `saveState` in interface `StateHolder`

    - #### restoreState

          public void restoreState(FacesContext context,
                          Object state)

      Description copied from interface: `StateHolder`

      Perform any processing required to restore the state from the entries in the state Object.

      If the class that implements this interface has references to instances that also implement StateHolder (such as a `UIComponent` with event handlers, validators, etc.) this method must call the `StateHolder.restoreState(javax.faces.context.FacesContext, java.lang.Object)` method on all those instances as well.

      If the `state` argument is `null`, take no action and return.

      Specified by:
        `restoreState` in interface `StateHolder`

    - #### markInitialState

          public void markInitialState()

      Description copied from interface: `PartialStateHolder`

      The runtime must ensure that the `PartialStateHolder.markInitialState()` method is called on each instance of this interface in the view at the appropriate time to indicate the component is in its initial state. The implementor of the interface must ensure that `PartialStateHolder.initialStateMarked()` returns `true` from the time `markInitialState()` is called until `PartialStateHolder.clearInitialState()` is called, after which time `initialStateMarked()` must return `false`. Also, during the time that the instance returns `true` from `initialStateMarked()`, the implementation must return only the state that has changed in its implementation of `StateHolder.saveState(javax.faces.context.FacesContext)`.

      Specified by:
        `markInitialState` in interface `PartialStateHolder`

    - #### initialStateMarked

          public boolean initialStateMarked()

      Description copied from interface: `PartialStateHolder`

      Return `true` if delta state changes are being tracked, otherwise `false`

      Specified by:
        `initialStateMarked` in interface `PartialStateHolder`

    - #### clearInitialState

          public void clearInitialState()

      Description copied from interface: `PartialStateHolder`

      Reset the PartialStateHolder to a non-delta tracking state.

      Specified by:
        `clearInitialState` in interface `PartialStateHolder`

    - #### isTransient

          public boolean isTransient()

      Description copied from interface: `StateHolder`

      If true, the Object implementing this interface must not participate in state saving or restoring.

      Specified by:
        `isTransient` in interface `StateHolder`

    - #### setTransient

          public void setTransient(boolean transientValue)

      Description copied from interface: `StateHolder`

      Denotes whether or not the Object implementing this interface must or must not participate in state saving or restoring.

      Specified by:
        `setTransient` in interface `StateHolder`
      Parameters:
        `transientValue` - boolean pass `true` if this Object will not participate in state saving or restoring, otherwise pass `false`.

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.